Index: /GTP/trunk/Lib/Vis/Preprocessing/src/KdTree.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/KdTree.cpp	(revision 2571)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/KdTree.cpp	(revision 2575)
@@ -1491,9 +1501,9 @@
   
   while (!node->IsLeaf() && (GetSurfaceArea(node) > maxArea) ) {
-	KdInterior *inter = (KdInterior *)node;
-	if (point[inter->mAxis] < inter->mPosition)
-	  node = inter->mBack;
-	else
-	  node = inter->mFront;
+    KdInterior *inter = (KdInterior *)node;
+    if (point[inter->mAxis] < inter->mPosition)
+      node = inter->mBack;
+    else
+      node = inter->mFront;
   }
   
@@ -1503,37 +1513,37 @@
 
 void KdTree::GetBoxIntersections(const AxisAlignedBox3 &box,
-								 vector<KdLeaf *> &leaves)
-{
-	stack<KdNode *> tStack;
-
-	tStack.push(mRoot);
-
-	while (!tStack.empty())
+				 vector<KdLeaf *> &leaves)
+{
+  stack<KdNode *> tStack;
+  
+  tStack.push(mRoot);
+  
+  while (!tStack.empty())
+    {
+      KdNode *node = tStack.top();
+      tStack.pop();
+      
+      if (node->IsLeaf())
 	{
-		KdNode *node = tStack.top();
-		tStack.pop();
-		
-		if (node->IsLeaf())
-		{
-			leaves.push_back(static_cast<KdLeaf *>(node));
-		}
-		else // interior
-		{
-			KdInterior *interior = static_cast<KdInterior *>(node);
-
-			if (box.Max(interior->mAxis) >= interior->mPosition)
-			{
-				tStack.push(interior->mFront);
-			}
-
-			if (box.Min(interior->mAxis) < interior->mPosition)
-			{
-				tStack.push(interior->mBack);
-			}
-		}
-	}
-}
-
-
-
-}
+	  leaves.push_back(static_cast<KdLeaf *>(node));
+	}
+      else // interior
+	{
+	  KdInterior *interior = static_cast<KdInterior *>(node);
+	  
+	  if (box.Max(interior->mAxis) >= interior->mPosition)
+	    {
+	      tStack.push(interior->mFront);
+	    }
+	  
+	  if (box.Min(interior->mAxis) < interior->mPosition)
+	    {
+	      tStack.push(interior->mBack);
+	    }
+	}
+    }
+}
+
+
+
+}
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/DifferenceSampling.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/DifferenceSampling.cpp	(revision 2560)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/DifferenceSampling.cpp	(revision 2575)
@@ -1,2 +1,3 @@
+
 #include "SamplingStrategy.h"
 #include "Intersectable.h"
@@ -5,6 +6,7 @@
 #include "ViewCellsManager.h"
 #include "Preprocessor.h"
+#ifdef PERFTIMER  
 #include "Timer/PerfTimer.h"
-
+#endif
 
 #ifdef GTP_INTERNAL
@@ -12,6 +14,8 @@
 #endif
 
+
+#ifdef PERFTIMER  
 PerfTimer sFilterTimer;
-
+#endif
 
 namespace GtpVisibilityPreprocessor {
@@ -63,6 +67,9 @@
 	ObjectPvs filteredPvs;
 
+	
+#ifdef PERFTIMER  
 	sFilterTimer.Entry();
-    
+#endif
+	
 	PvsFilterStatistics pvsStats = mPreprocessor.
 		mViewCellsManager->ApplyFilter2(vc, 
@@ -71,6 +78,8 @@
 										filteredPvs);
 
+#ifdef PERFTIMER  
 	sFilterTimer.Exit();
-
+#endif
+	
 	//mDifferencePvs.Clear(false);
 	//mDifferencePvs.Reserve(filteredPvs.GetSize());
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Halton.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Halton.cpp	(revision 2227)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Halton.cpp	(revision 2575)
@@ -1,5 +1,7 @@
 #include "Halton.h"
+
+#ifdef PERFTIMER  
 #include "Timer/PerfTimer.h"
-
+#endif
 
 #define PREGENERATE_HALTON 0
@@ -7,6 +9,9 @@
 namespace GtpVisibilityPreprocessor {
 
+  
+#ifdef PERFTIMER  
 PerfTimer haltonTimer;
-
+#endif
+  
 // global halton generator
 
@@ -14,12 +19,8 @@
   float Halton2::_invBases[2];
 
-  float Halton<1>::_invBases[1];
-  float Halton<2>::_invBases[2];
-  float Halton<3>::_invBases[3];
-  float Halton<4>::_invBases[4];
-  float Halton<5>::_invBases[5];
-  float Halton<6>::_invBases[6];
+  //float Halton<6>::_invBases[6];
   
-
+  template<int T> float Halton<T>::_invBases[T];
+  
   Halton<1> dummmyHalton1(true);
   Halton<2> dummmyHalton2(true);
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Vector3.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Vector3.cpp	(revision 1883)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Vector3.cpp	(revision 2575)
@@ -2,6 +2,5 @@
 #include "Vector3.h"
 #include "Halton.h"
-#include "float.h"
-
+#include <float.h>
 
 namespace GtpVisibilityPreprocessor {
@@ -316,7 +315,11 @@
 bool Vector3::CheckValidity() const
 {
-	return !(_isnan(x) || _isnan(y) || _isnan(z));
-	 //return ((x != x) || (y != y) || (z != z));
-}
-
-}
+#ifdef _WIN32
+  return !(_isnan(x) || _isnan(y) || _isnan(z));
+#else
+  return !(isnan(x) || isnan(y) || isnan(z));
+#endif  
+  //return ((x != x) || (y != y) || (z != z));
+}
+
+}
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/RssTree.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/RssTree.cpp	(revision 2130)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/RssTree.cpp	(revision 2575)
@@ -1481,12 +1481,12 @@
 void
 RssTree::RemoveRay(VssRay *ray,
-				   vector<RssTreeLeaf *> *affectedLeaves,
-				   const bool removeAllScheduledRays
-				   )
-{
-	
-  stack<RayTraversalData> tstack;
-
-  PushRoots(tstack, RssTreeLeaf::RayInfo(ray));
+		   vector<RssTreeLeaf *> *affectedLeaves,
+		   const bool removeAllScheduledRays
+		   )
+{	
+  TstackEntry tstack;
+
+  RssTreeNode::RayInfo ri(ray);
+  PushRoots(tstack, ri);
   
   RayTraversalData data;
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Triangle3.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Triangle3.cpp	(revision 2542)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Triangle3.cpp	(revision 2575)
@@ -1,4 +1,5 @@
 #include "Triangle3.h"
 #include "Ray.h"
+#include "SimpleRay.h"
 #include "AxisAlignedBox3.h"
 #include "Containers.h"
@@ -33,98 +34,196 @@
 int
 Triangle3::CastRay(const Ray &ray,
-				   float &t,
-				   const float nearestT,
-				   Vector3 &normal) const
-{
-	//////////////
-	// specialised triangle ray casting version
-	// using ray-plane intersection
-	
-	// get triangle edge vectors and plane normal
-	const Vector3 u = mVertices[0] - mVertices[1];
-    const Vector3 v = mVertices[2] - mVertices[1];
-
-	// cross product
-    normal = Normalize(CrossProd(v, u));
-
-	// ray direction vector
-    const Vector3 dir = ray.GetDir();
-    const Vector3 w0 = ray.GetLoc() - mVertices[1];
-
-	// params to calc ray-plane intersect
-    const float a = -DotProd(normal, w0);
-    const float b = DotProd(normal, dir);
-
-	// check for division by zero
-	if (fabs(b) < Limits::Small) 
-	{   
-		// ray is parallel to triangle plane
-        if (a == 0)
-		{
-			// ray lies in triangle plane
-            return Ray::INTERSECTION_OUT_OF_LIMITS;
-		}
-        else
-		{
-			// ray disjoint from plane
-			return Ray::NO_INTERSECTION;
-		}
-    }
-
-    // distance from origin of ray to plane
-    t = a / b;
-
-    if (t <= Limits::Small) // ray goes away from triangle
-	{
+		   float &t,
+		   const float nearestT,
+		   Vector3 &normal) const
+{
+  //////////////
+  // specialised triangle ray casting version
+  // using ray-plane intersection
+  
+  // get triangle edge vectors and plane normal
+  const Vector3 u = mVertices[0] - mVertices[1];
+  const Vector3 v = mVertices[2] - mVertices[1];
+  
+  // cross product
+  normal = Normalize(CrossProd(v, u));
+  
+  // ray direction vector
+  const Vector3 dir = ray.GetDir();
+  const Vector3 w0 = ray.GetLoc() - mVertices[1];
+  
+  // params to calc ray-plane intersect
+  const float a = -DotProd(normal, w0);
+  const float b = DotProd(normal, dir);
+  
+  // check for division by zero
+  if (fabs(b) < Limits::Small) 
+    {   
+      // ray is parallel to triangle plane
+      if (a == 0)
+	{
+	  // ray lies in triangle plane
 	  return Ray::INTERSECTION_OUT_OF_LIMITS;
 	}
-	// already found nearer intersection
-	else if ((ray.GetType() == Ray::LOCAL_RAY) && (t >= nearestT))
-	{
-		return Ray::NO_INTERSECTION;
-	}
-
-	/////////////////
+      else
+	{
+	  // ray disjoint from plane
+	  return Ray::NO_INTERSECTION;
+	}
+    }
+
+  // distance from origin of ray to plane
+  t = a / b;
+  
+  if (t <= Limits::Small) // ray goes away from triangle
+    {
+      return Ray::INTERSECTION_OUT_OF_LIMITS;
+    }
+  // already found nearer intersection
+  else if ((ray.GetType() == Ray::LOCAL_RAY) && (t >= nearestT))
+    {
+      return Ray::NO_INTERSECTION;
+    }
+  
+  /////////////////
     //-- found intersection point
-	//-- check if it is inside triangle
-  
-	const Vector3 pt = ray.GetLoc() + t * dir; 
+  //-- check if it is inside triangle
+  
+  const Vector3 pt = ray.GetLoc() + t * dir; 
 #if GTP_DEBUG
-	if (!pt.CheckValidity())
-	{
-		cout << "tr: " << *this << endl;
-		cout << "v: " << pt << " t: " << t << " a: " << a << " b: " << b << " n: " << normal << endl;
-	}
+  if (!pt.CheckValidity())
+    {
+      cout << "tr: " << *this << endl;
+      cout << "v: " << pt << " t: " << t << " a: " << a << " b: " << b << " n: " << normal << endl;
+    }
 #endif
-	const Vector3 w = pt - mVertices[1];
-
-	const float uu = DotProd(u, u);
-    const float uv = DotProd(u, v);
-    const float vv = DotProd(v, v);
+  const Vector3 w = pt - mVertices[1];
+  
+  const float uu = DotProd(u, u);
+  const float uv = DotProd(u, v);
+  const float vv = DotProd(v, v);
+  
+  const float wu = DotProd(w, u);
+  const float wv = DotProd(w, v);
+  
+  
+  const float D = uv * uv - uu * vv;
+  
+  // get and test parametric coords
+  const float s = (uv * wv - vv * wu) / D;
+  
+  if ((s < -Limits::Small) || (s > 1.0f + Limits::Small)) // pt is outside triangle
+    {	
+      return Ray::NO_INTERSECTION;
+    }
+  
+  const float s2 = (uv * wu - uu * wv) / D;
+  
+  if ((s2 < -Limits::Small) || ((s + s2) > 1.0f + Limits::Small)) // pt is outside triangle
+    {	
+      return Ray::NO_INTERSECTION;
+    }
+  
+  return Ray::INTERSECTION; // I is in T
+}
+
+
+int
+Triangle3::CastSimpleRay(const SimpleRay &ray,
+			 float &t,
+			 const float nearestT) const
+{
+  //////////////
+  // specialised triangle ray casting version
+  // using ray-plane intersection
+  
+  // get triangle edge vectors and plane normal
+  const Vector3 u = mVertices[0] - mVertices[1];
+  const Vector3 v = mVertices[2] - mVertices[1];
+
+  // cross product
+  const Vector3 normal = Normalize(CrossProd(v, u));
+
+  // ray direction vector
+  const Vector3 dir = ray.mDirection;
+  const Vector3 w0 = ray.mOrigin - mVertices[1];
+
+  // params to calc ray-plane intersect
+  const float a = -DotProd(normal, w0);
+  const float b = DotProd(normal, dir);
+
+  // check for division by zero
+  if (fabs(b) < Limits::Small) 
+  {   
+    // ray is parallel to triangle plane
+    if (a == 0)
+    {
+      // ray lies in triangle plane
+      return Ray::INTERSECTION_OUT_OF_LIMITS;
+    }
+    else {
+      // ray disjoint from plane
+      return Ray::NO_INTERSECTION;
+    }
+  }
+
+  // distance from origin of ray to plane
+  t = a / b;
+
+  if (t <= Limits::Small) // ray goes away from triangle
+  {
+    return Ray::INTERSECTION_OUT_OF_LIMITS;
+  }
+
+  // already found nearer intersection
+  if (t > nearestT + 1e-5)
+  {
+    return Ray::NO_INTERSECTION;
+  }
+
+  /////////////////
+  //-- found intersection point
+  //-- check if it is inside triangle
+  
+  const Vector3 pt = ray.mOrigin + t * dir; 
+#if GTP_DEBUG
+  if (!pt.CheckValidity())
+  {
+    cout << "tr: " << *this << endl;
+    cout << "v: " << pt << " t: " << t << " a: " << a << " b: " << b << " n: " << normal << endl;
+  }
+#endif
+  const Vector3 w = pt - mVertices[1];
+
+  const float uu = DotProd(u, u);
+  const float uv = DotProd(u, v);
+  const float vv = DotProd(v, v);
     
-	const float wu = DotProd(w, u);
-    const float wv = DotProd(w, v);
-
-
-	const float D = uv * uv - uu * vv;
-
-    // get and test parametric coords
-    const float s = (uv * wv - vv * wu) / D;
-
-    if ((s < -Limits::Small) || (s > 1.0f + Limits::Small)) // pt is outside triangle
-	{	
-        return Ray::NO_INTERSECTION;
-	}
-
-	const float s2 = (uv * wu - uu * wv) / D;
-
-    if ((s2 < -Limits::Small) || ((s + s2) > 1.0f + Limits::Small)) // pt is outside triangle
-	{	
-        return Ray::NO_INTERSECTION;
-	}
-
-	return Ray::INTERSECTION; // I is in T
-}
-
+  const float wu = DotProd(w, u);
+  const float wv = DotProd(w, v);
+  
+  
+  const float D = uv * uv - uu * vv;
+  
+  // get and test parametric coords
+  const float s = (uv * wv - vv * wu) / D;
+  
+  if ((s < -Limits::Small) ||
+      (s > 1.0f + Limits::Small)) // pt is outside triangle
+  {	
+    return Ray::NO_INTERSECTION;
+  }
+
+  const float s2 = (uv * wu - uu * wv) / D;
+  
+  if ((s2 < -Limits::Small) ||
+      ((s + s2) > 1.0f + Limits::Small)) // pt is outside triangle
+  {	
+    return Ray::NO_INTERSECTION;
+  }
+  
+  return Ray::INTERSECTION; // I is in T
+}
+  
 
 AxisAlignedBox3 Triangle3::GetBoundingBox() const
@@ -137,4 +236,6 @@
 	box.Include(mVertices[2]);
 
+	box.EnlargeToMinSize();
+	
 	return box;
 }
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.cpp	(revision 2547)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.cpp	(revision 2575)
@@ -709,6 +709,8 @@
 							const bool globalCriteriaMet)
 {
+#ifdef PERFTIMER  
 	mSubdivTimer.Entry();
-
+#endif
+	
 	// todo remove dynamic cast
 	VspSubdivisionCandidate *sc = 
@@ -788,6 +790,7 @@
 	}
 
+#ifdef PERFTIMER  
 	mSubdivTimer.Exit();
-
+#endif
 	return newNode;
 }
@@ -797,6 +800,8 @@
 									   bool computeSplitPlane)
 {
+#ifdef PERFTIMER  
 	mPlaneTimer.Entry();
-
+#endif
+	
 	if (computeSplitPlane)
 	{
@@ -818,7 +823,9 @@
 	}
 	
+#ifdef PERFTIMER  
 	mPlaneTimer.Exit();
 	mEvalTimer.Entry();
-
+#endif
+	
 	VspLeaf *leaf = static_cast<VspLeaf *>(splitCandidate.mParentData.mNode);
 
@@ -917,5 +924,7 @@
 
 	//cout << "vsp render cost decrease=" << renderCostDecr << endl;
+#ifdef PERFTIMER  
 	mEvalTimer.Exit();
+#endif
 }
 
@@ -948,6 +957,7 @@
 									VspTraversalData &backData)
 {
+#ifdef PERFTIMER  
 	mNodeTimer.Entry();
-	
+#endif	
 	VspLeaf *leaf = static_cast<VspLeaf *>(sc.mParentData.mNode);
 
@@ -1042,6 +1052,7 @@
 	interior->mTimeStamp = mHierarchyManager->mTimeStamp ++;
 
+#ifdef PERFTIMER  
 	mNodeTimer.Exit();
-
+#endif
 	return interior;
 }
@@ -1103,6 +1114,7 @@
 										float maxBand)
 {
+#ifdef PERFTIMER  
 	mSortTimer.Entry();
-
+#endif
 	mLocalSubdivisionCandidates->clear();
 
@@ -1154,5 +1166,7 @@
 		sort(mLocalSubdivisionCandidates->begin(), mLocalSubdivisionCandidates->end());
 
+#ifdef PERFTIMER  
 	mSortTimer.Exit();
+#endif
 }
 
@@ -1573,6 +1587,7 @@
 								float &pBack)
 {
+#ifdef PERFTIMER  
 	mSplitTimer.Entry();
-
+#endif
 	float nPosition[3];
 	float nCostRatio[3];
@@ -1670,6 +1685,7 @@
 	pBack = nProbBack[bestAxis];
 
+#ifdef PERFTIMER  
 	mSplitTimer.Exit();
-
+#endif
 	return nCostRatio[bestAxis];
 }
@@ -3158,5 +3174,7 @@
 void VspTree::GetViewCells(const VssRay &ray, ViewCellContainer &viewCells)
 {
+#ifdef PERFTIMER  
 	mViewCellsTimer.Entry();
+#endif
 	
 	static Ray hray;
@@ -3175,5 +3193,7 @@
 	CastLineSegment(origin, termination, viewCells, false);
 
+#ifdef PERFTIMER  
 	mViewCellsTimer.Exit();
+#endif
 }
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/VssRay.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/VssRay.h	(revision 2353)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/VssRay.h	(revision 2575)
@@ -151,6 +151,6 @@
   float GetOpositeDirParametrization(const int axis) const;
 
-  static float VssRay::GetDirParam(const int axis, const Vector3 dir);
-  static Vector3 VssRay::GetInvDirParam(const float alpha, const float beta);
+  static float GetDirParam(const int axis, const Vector3 dir);
+  static Vector3 GetInvDirParam(const float alpha, const float beta);
 
   float GetSize() const { return  1.0f/mInvSize; }
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/RayCaster.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/RayCaster.cpp	(revision 2539)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/RayCaster.cpp	(revision 2575)
@@ -270,10 +270,10 @@
 int
 RayCaster::ProcessRay(const SimpleRay &simpleRay,
-					  Intersection &hitA,
-					  Intersection &hitB,
-					  VssRayContainer &vssRays,
-					  const AxisAlignedBox3 &box,
-					  const bool castDoubleRay,
-					  const bool pruneInvalidRays)
+		      Intersection &hitA,
+		      Intersection &hitB,
+		      VssRayContainer &vssRays,
+		      const AxisAlignedBox3 &box,
+		      const bool castDoubleRay,
+		      const bool pruneInvalidRays)
 {
   int hits = 0;
@@ -325,4 +325,8 @@
 	Debug<<"PR2"<<flush;
 #endif
+
+	// VH - I do not know what this is for, commented out temporarily
+	// !!!!!!!!!!!!!! !!!!!!!!!!!! !!!!!!!!!!
+#if 1
 	const bool validSample = true;
 	if (validSample) {
@@ -363,11 +367,11 @@
 	{
 		VssRay *vssRay = RequestRay(
-									clipA,
-									hitB.mPoint,
-									hitA.mObject,
-									hitB.mObject,
-									mPreprocessor.mPass,
-									1.0f //simpleRay.mPdf
-									);
+					    clipA,
+					    hitB.mPoint,
+					    hitA.mObject,
+					    hitB.mObject,
+					    mPreprocessor.mPass,
+					    1.0f //simpleRay.mPdf
+					    );
 
 		if (validB)
@@ -383,5 +387,10 @@
 	  Debug<<"PR4"<<flush;
 #endif
-	}
+	} // validSample
+#else
+	// Just pass if intersected or not
+	hits = (hitA.mObject != 0) ? 1 : 0;
+	intersect = hitA;
+#endif	
 	
 	return hits;
@@ -391,23 +400,23 @@
 void
 RayCaster::CastRays(
-					SimpleRayContainer &rays,
-					VssRayContainer &vssRays,
-					const AxisAlignedBox3 &sbox,
-					const bool castDoubleRay,
-					const bool pruneInvalidRays )
-{
-	SimpleRayContainer::const_iterator rit, rit_end = rays.end();
-
-	for (rit = rays.begin(); rit != rit_end; ++ rit) {
-		
-		CastRay(
-			*rit,				
-			vssRays,
-			sbox,
-			castDoubleRay,
-			pruneInvalidRays);
-	}
-}
-
-
-}
+		    SimpleRayContainer &rays,
+		    VssRayContainer &vssRays,
+		    const AxisAlignedBox3 &sbox,
+		    const bool castDoubleRay,
+		    const bool pruneInvalidRays )
+{
+  SimpleRayContainer::const_iterator rit, rit_end = rays.end();
+  
+  for (rit = rays.begin(); rit != rit_end; ++ rit) {
+    
+    CastRay(
+	    *rit,				
+	    vssRays,
+	    sbox,
+	    castDoubleRay,
+	    pruneInvalidRays);
+	}
+}
+  
+
+}
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Environment.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Environment.h	(revision 2176)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Environment.h	(revision 2575)
@@ -17,9 +17,10 @@
 
 #include "common.h"
+#include <cstring>
+
 
 namespace GtpVisibilityPreprocessor {
 
 class Vector3;
-
 
 /// Enumeration type used to distinguish the type of the environment variable
@@ -314,6 +315,10 @@
   /// returns named option as a character string.
   bool GetStringValue(const char *name,
-					  char *value,
-					  const bool isFatal = false) const;
+		      char *value,
+		      const bool isFatal = false) const;
+
+  bool GetStringValue(const char *name,
+		      std::string &stringVariable,
+		      const bool isFatal = false) const;
   
   //@}
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/KdTree.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/KdTree.h	(revision 2539)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/KdTree.h	(revision 2575)
@@ -9,5 +9,5 @@
 #include "Ray.h"
 //#include "ObjectPvs.h"
-#include "Viewcell.h"
+#include "ViewCell.h"
 #include "VssRay.h"
 //#include "IntersectableWrapper.h"
@@ -96,6 +96,6 @@
 /** Abstract class for kd-tree node */
 class KdNode {
-public:
-  
+
+public:  
   static int sMailId;
   static int sReservedMailboxes;
@@ -109,9 +109,9 @@
  
   static void NewMail(const int reserve = 1) {
-		sMailId += sReservedMailboxes;
-		sReservedMailboxes = reserve;
-	}
-	void Mail(const int mailbox) { mMailbox = sMailId + mailbox; }
-	bool Mailed(const int mailbox) const { return mMailbox == sMailId + mailbox; }
+    sMailId += sReservedMailboxes;
+    sReservedMailboxes = reserve;
+  }
+  void Mail(const int mailbox) { mMailbox = sMailId + mailbox; }
+  bool Mailed(const int mailbox) const { return mMailbox == sMailId + mailbox; }
 
   virtual ~KdNode(){};
@@ -183,5 +183,6 @@
 public:
   KdLeaf(KdInterior *parent, const int objects):
-	  KdNode(parent), mViewCell(NULL), mVboId(-1), mIndexBufferStart(0), mIndexBufferSize(0) {
+	  KdNode(parent), mViewCell(NULL), mVboId(-1),
+	  mIndexBufferStart(0), mIndexBufferSize(0) {
     mObjects.reserve(objects);
   }
@@ -194,8 +195,8 @@
   ~KdLeaf();
 	
-	void AddPassingRay2(const Ray &ray,
-						const int objects,
-						const int viewcells
-						) {
+  void AddPassingRay2(const Ray &ray,
+		      const int objects,
+		      const int viewcells
+		      ) {
     mPassingRays.AddRay2(ray, objects, viewcells);
 		//		Debug << "adding passing ray" << endl;
@@ -246,17 +247,16 @@
     
     TraversalData(KdNode *n,
-		   const AxisAlignedBox3 &b,
-		   const int d):
+		  const AxisAlignedBox3 &b,
+		  const int d):
       mNode(n), mBox(b), mDepth(d) {}
     
 
-    bool operator<(
-				   const TraversalData &b) const {
+    bool operator<(const TraversalData &b) const {
       KdLeaf *leafa = (KdLeaf *) mNode;
       KdLeaf *leafb = (KdLeaf *) b.mNode;
       return 
-		leafa->mObjects.size()*mBox.SurfaceArea()
-		<
-		leafb->mObjects.size()*b.mBox.SurfaceArea();
+	leafa->mObjects.size()*mBox.SurfaceArea()
+	<
+	leafb->mObjects.size()*b.mBox.SurfaceArea();
     }
 
@@ -267,5 +267,5 @@
       
       bool operator()(const TraversalData a, const TraversalData b) {
-				return a.mPriority < b.mPriority;
+	return a.mPriority < b.mPriority;
       }
       
@@ -329,6 +329,6 @@
   */
   int CastLineSegment(const Vector3 &origin,
-					  const Vector3 &termination,
-					  vector<ViewCell *> &viewcells);
+		      const Vector3 &termination,
+		      vector<ViewCell *> &viewcells);
 
 
@@ -351,6 +351,6 @@
   void
   CollectKdObjects(const AxisAlignedBox3 &box,
-				   ObjectContainer &objects
-				   );
+		   ObjectContainer &objects
+		   );
 
   void
@@ -359,5 +359,5 @@
   void
   CollectObjects(const AxisAlignedBox3 &box,
-				 ObjectContainer &objects);
+		 ObjectContainer &objects);
 
   void
@@ -388,5 +388,5 @@
 
   float GetSurfaceArea(const KdNode *node) const {
-	return GetBox(node).SurfaceArea();
+    return GetBox(node).SurfaceArea();
   }
 
@@ -394,9 +394,9 @@
   KdNode *
   FindRandomNeighbor(KdNode *n,
-					 bool onlyUnmailed
-					 );
+		     bool onlyUnmailed
+		     );
   
   KdNode *
-  KdTree::GetRandomLeaf(const Plane3 &halfspace);
+  GetRandomLeaf(const Plane3 &halfspace);
 
   KdNode *
@@ -408,11 +408,11 @@
 
   void GetBoxIntersections(const AxisAlignedBox3 &box, 
-						   vector<KdLeaf *> &leaves);
+			   vector<KdLeaf *> &leaves);
 
   int
   FindNeighbors(KdNode *n,
-				vector<KdNode *> &neighbors,
-				bool onlyUnmailed
-				);
+		vector<KdNode *> &neighbors,
+		bool onlyUnmailed
+		);
 
   bool ExportBinTree(const std::string &filename);
@@ -439,6 +439,6 @@
 #if USE_FIXEDPOINT_T
 #define FIXEDPOINT_ONE 0x7FFE
-			  //			  tmax(0xFFFF)
-			  tmax(FIXEDPOINT_ONE)
+		    //			  tmax(0xFFFF)
+		    tmax(FIXEDPOINT_ONE)
 #else
       tmax(1.0f)
@@ -531,7 +531,7 @@
     
     SortableEntry() {}
-    SortableEntry(const int t, const float v, Intersectable *i):type(t),
-								value(v),
-								intersectable(i) {}
+    SortableEntry(const int t, const float v, Intersectable *i):
+      type(t), value(v), intersectable(i)
+    { }
     
     bool operator<(const SortableEntry &b) const {
@@ -561,7 +561,7 @@
   void
   SortSubdivisionCandidates(
-		      KdLeaf *node,
-		      const int axis
-		      );
+			    KdLeaf *node,
+			    const int axis
+			   );
 
   void
@@ -585,26 +585,28 @@
 	      );
 
-	/** does some post processing on the objects in the new child leaves.
-	*/
-	void ProcessMultipleRefs(KdLeaf *leaf) const;
-
-
-	//////////
-	// binary import / export
-
-	void ExportBinLeaf(OUT_STREAM  &stream, KdLeaf *leaf);
+  /** does some post processing on the objects in the new child leaves.
+   */
+  void ProcessMultipleRefs(KdLeaf *leaf) const;
+
+
+  //////////
+  // binary import / export
+  
+  void ExportBinLeaf(OUT_STREAM  &stream, KdLeaf *leaf);
 	
-	void ExportBinInterior(OUT_STREAM &stream, KdInterior *interior);
-
-	KdLeaf *ImportBinLeaf(IN_STREAM &stream, KdInterior *parent, const ObjectContainer &objects);
+  void ExportBinInterior(OUT_STREAM &stream, KdInterior *interior);
+  
+  KdLeaf *ImportBinLeaf(IN_STREAM &stream, KdInterior *parent,
+			const ObjectContainer &objects);
 	
-	KdInterior *ImportBinInterior(IN_STREAM  &stream, KdInterior *parent);
+  KdInterior *ImportBinInterior(IN_STREAM  &stream, KdInterior *parent);
+  
+  KdNode *ImportNextNode(IN_STREAM  &stream, KdInterior *parent,
+			 const ObjectContainer &objects);
 	
-	KdNode *ImportNextNode(IN_STREAM  &stream, KdInterior *parent, const ObjectContainer &objects);
-	
-	/** Adds this objects to the kd leaf objects.
-		@warning: Can corrupt the tree
-	*/
-	void InsertObjects(KdNode *node, const ObjectContainer &objects);
+  /** Adds this objects to the kd leaf objects.
+      @warning: Can corrupt the tree
+  */
+  void InsertObjects(KdNode *node, const ObjectContainer &objects);
 
   int mTermMaxNodes;
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 2569)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 2575)
@@ -6,8 +6,13 @@
 
 #define NOMINMAX
+#ifdef __WINDOWS__
 #include <windows.h>
-#include <stdio.h>
+#ifdef _CRT_SET
 #include <crtdbg.h>
-
+#endif // _CRT_SET
+#endif
+#include <cstdio>
+
+#include "Camera.h"
 #include "PreprocessorFactory.h"
 #include "Parser.h"
@@ -20,4 +25,6 @@
 #include "SceneGraph.h"
 #include "GlobalLinesRenderer.h"
+#include "RayCaster.h"
+//#include "testrt.h"
 
 #include "ViewCellsManager.h"
@@ -152,9 +159,27 @@
 }
 
-
 int
 main(int argc, char **argv)
 {
-	int returnCode = 0;
+#if 0
+  // Test code by VH
+  //TestRTcamera(argc, argv);
+  //TestRTfromFile(argc, argv);
+  TestRTfromFilePackets(argc, argv);
+  return 0;
+#endif
+
+  int returnCode = 0;
+
+  //Now just call this function at the start of your program and if you're
+  //compiling in debug mode (F5), any leaks will be displayed in the Output
+  //window when the program shuts down. If you're not in debug mode this will
+  //be ignored. Use it as you will!
+  //note: from GDNet Direct [3.8.04 - 3.14.04] void detectMemoryLeaks() {
+#ifdef _CRT_SET
+  _CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF|_CRTDBG_ALLOC_MEM_DF);
+  _CrtSetReportMode(_CRT_ASSERT,_CRTDBG_MODE_FILE);
+  _CrtSetReportFile(_CRT_ASSERT,_CRTDBG_FILE_STDERR); 
+#endif
 
 	//Now just call this function at the start of your program and if you're
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ObjParser.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ObjParser.cpp	(revision 2539)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ObjParser.cpp	(revision 2575)
@@ -209,5 +209,7 @@
 	const Vector3 cross_a_b = CrossProd(a, b);
 
-	if (SqrMagnitude(cross_a_b) <= 0.000001 * FLT_EPSILON * FLT_EPSILON) 
+#define SMALL_FLT   1e-5
+	
+	if (SqrMagnitude(cross_a_b) <= 0.0001 * SMALL_FLT * SMALL_FLT) 
 	{
 		// v0, v1 & v2 lies on a line (area == 0)
@@ -293,9 +295,10 @@
 					for (tit = triangles.begin(); tit != tit_end; ++ tit)
 					{
-						// test if it is a valid triangle
-						if (0 && !TriangleValid(*tit)) continue;
-
-						TriangleIntersectable *obj = new TriangleIntersectable(*tit);	
-						root->mGeometry.push_back(obj);
+					  // test if it is a valid triangle
+					  if (!TriangleValid(*tit))
+					    continue;
+
+					  TriangleIntersectable *obj = new TriangleIntersectable(*tit);	
+					  root->mGeometry.push_back(obj);
 					}
 				}
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ResourceManager.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ResourceManager.h	(revision 2542)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ResourceManager.h	(revision 2575)
@@ -4,4 +4,8 @@
 #include <vector>
 #include <string>
+#include <iterator>
+#include <fstream>
+#include <ostream>
+#include <iostream>
 
 //#include "Containers.h"
@@ -13,4 +17,7 @@
 namespace GtpVisibilityPreprocessor {
 
+using std::iterator;
+using std::map;
+  
 
 /** Resource manager controlling loading and destroying of resources.
@@ -25,5 +32,10 @@
 template <typename T> class ResourceManager
 {
+protected:
+  typedef map<unsigned int, T* > maptype;
 
+  /// the resource container
+  maptype mEntries;
+  
 public:
 
@@ -65,10 +77,10 @@
 	T *FindEntry(const unsigned int id) const
 	{
-		std::map<unsigned int, T *>::const_iterator mit = mEntries.find(id);
+	  typename maptype::const_iterator mit = mEntries.find(id);
 
-		if (mit != mEntries.end()) 
-		{
-			return (*mit).second;
-		}
+	  if (mit != mEntries.end()) 
+	    {
+	      return (*mit).second;
+	    }
 
 		return NULL;
@@ -95,10 +107,10 @@
 	bool ExportEntries(const std::string &filename)
 	{
-		ofstream stream(filename.c_str(), ios::binary);
+	  std::ofstream stream(filename.c_str(), std::ios::binary);
 	
 		if (!stream.is_open())
 			return false;
 
-		std::map<unsigned int, T *>::const_iterator mit, mit_end = mEntries.end();
+		typename std::map<unsigned int, T *>::const_iterator mit, mit_end = mEntries.end();
 
 		for (mit = mEntries.begin(); mit != mit_end; ++ mit)
@@ -130,5 +142,5 @@
 	~ResourceManager<T>()
 	{
-		std::map<unsigned int, T *>::iterator mit, mit_end = mEntries.end();
+	  typename std::map<unsigned int, T *>::iterator mit, mit_end = mEntries.end();
 
 		for (mit = mEntries.begin(); mit != mEntries.end(); ++ mit)
@@ -152,7 +164,4 @@
 protected:
 
-	/// the resource container
-	std::map<unsigned int, T *> mEntries;
-
 private:
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Intersectable.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Intersectable.h	(revision 2543)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Intersectable.h	(revision 2575)
@@ -21,12 +21,12 @@
 struct FaceParentInfo 
 {
-	/// intersectable
-	Intersectable *mObject;
-	/// face index
-	int mFaceIndex;
-
-	FaceParentInfo(Intersectable *obj, const int fi):
-	mObject(obj), mFaceIndex(fi)
-	{}
+  /// intersectable
+  Intersectable *mObject;
+  /// face index
+  int mFaceIndex;
+  
+  FaceParentInfo(Intersectable *obj, const int fi):
+    mObject(obj), mFaceIndex(fi)
+  {}
 };
 
@@ -89,4 +89,6 @@
 	virtual AxisAlignedBox3 GetBox() const = 0;
 	virtual int CastRay(Ray &ray) = 0;
+	virtual int CastSimpleRay(const SimpleRay &ray) = 0;
+        virtual int CastSimpleRay(const SimpleRay &ray, int indexRay) = 0;
 
 	virtual bool IsConvex() const = 0;
@@ -157,5 +159,4 @@
 	BvhLeaf *mBvhLeaf;
 
-
 protected:
 
